saveSurface=sSurface;
%Implemen the las vegas method for determining the solution
PDEPTH=SLICE;%*3;%200;

%redistributing the surface segments to the ray projection point at DEPTH
dd=intensity;
indxr=zeros(ESIZE-1,1);
countt=0;
for i=1:ESIZE
    countt=countt+intensity(i);
end

for i=1:countt
    j=1+int32(rand *(ESIZE-1));
    while(dd(j)==0)
        j=mod(j+1,ESIZE);
        if(j==0) 
            j=1;
        end
    end
    dd(j)=dd(j)-1;
    indxr(i)=j+1;
end
%redistribute the right end of surface where rays map outside projection
%range
if(countt<ESIZE-1)
   for i=countt:ESIZE
       rnd=1+int32(rand*(ESIZE-1));
       temp=indxr(rnd);
       indxr(rnd)=indxr(i-1);
       indxr(i)=temp;
   end
end

%reconstructing the surface
rSurface = zeros(ESIZE,1);
rSurface(1)=0;
for i=2:ESIZE
    if(indxr(i-1)<1 || indxr(i-1)>ESIZE )
        if(i<ESIZE/2)
            indxr(i-1)=0;
        else
            indxr(i-1)=ESIZE+1;
        end
    end
    SPD=rSurface(i-1)+PDEPTH;
    triangle=sqrt(SPD^2-2*(indxr(i-1)-(i+0.5)));
    rSurface(i)=(rSurface(i-1)+(-SPD+triangle));
end
    %rSurface=rSurface*1.4;
%Start building the projection
xmax=max(rSurface);
xmin=min(rSurface);
difference=abs(xmax-xmin);% pad the the variations fo surface functions to the top of the matrix
diff32=int32(difference);
Projection=zeros(diff32+PDEPTH,ESIZE); % setup the image space
for i=1:ESIZE
    tmpX=int32(rSurface(i)*2)+diff32;
    if(tmpX>0)
        Projection(tmpX,i) = 10;
    end
end

% subplot(4,2,7);
% plot(intensity);title('Light intensity - Original');
% subplot(4,2,3);
% plot(indxr);title('indexer');
% subplot(4,2,1);
% plot(-rSurface);title('Random Water Surface');
% subplot(2,2,2);


sSurface=rSurface;
%find the x-derivative
sssdrv=zeros(ESIZE-1,1);
for i=1:ESIZE-1
    sssdrv(i) = (sSurface(i+1)-sSurface(i));
end


%start building the projection matrix (the matrix holding the ray paths)
curS=(1:(ESIZE-1))+0.5; % half way between two vertices.
xmin=min(sSurface);
xmax=max(sSurface);
difference=abs(xmax-xmin);% pad the the variations fo surface functions to the top of the matrix
diff32=int32(difference);
Projection=zeros(diff32+PDEPTH,ESIZE); % setup the image space
for d=1:diff32+PDEPTH % d is depth from maximum of the surface function.
    for v=1:ESIZE-1
        if((d-diff32)>sSurface(v))
            curS(v)=curS(v)-sssdrv(v);
            tmpX=int32(curS(v));
            if( tmpX > 0 && tmpX < ESIZE)
                Projection(d,tmpX)=Projection(d,tmpX)+1;
            end
        end
    end
end
for i=1:ESIZE
    tmpX=int32(sSurface(i))+diff32;
    if(tmpX>0)
        Projection(tmpX,i)=10;
    end
end

% imagesc(Projection);
% subplot(4,2,5);
% plot(Projection(d,:));title('Light intensity - Computed');
% subplot(4,2,6);
% imagesc(Projection(d,:));
% subplot(4,2,8);
% imagesc(intensity);
% figure(gcf);

countt1=0;
countt2=0;
for i=1:ESIZE
    countt1=countt1+intensity(i);
    countt2=countt2+Projection(PDEPTH,i);
end
sssdrv=zeros(ESIZE-1,1);
    for i=1:ESIZE-1
        sssdrv(i) = (sSurface(i+1)-sSurface(i));
    end


    %start building the projection matrix (the matrix holding the ray paths)
    curS=(1:(ESIZE-1))+0.5; % half way between two vertices.
    xmin=min(sSurface);
    xmax=max(sSurface);
    difference=abs(-xmin+1);% pad the the variations fo surface functions to the top of the matrix
    diff32=int32(difference);
    Projection=zeros(diff32+PDEPTH,ESIZE); % setup the image space
    for d=1:diff32+PDEPTH % d is depth from maximum of the surface function.
        for v=1:ESIZE-1
            if((d-diff32)>sSurface(v))
                curS(v)=curS(v)-sssdrv(v);
                tmpX=int32(curS(v));
                if( tmpX > 0 && tmpX < ESIZE)
                    Projection(d,tmpX)=Projection(d,tmpX)+1;
                end
            end
        end
    end
for i=1:ESIZE
    tmpX=int32(sSurface(i))+diff32;
    if(tmpX>0)
        Projection(1:tmpX,i)=-10;
        Projection(tmpX,i)=10;
    end
end
    % end of building the projection 
%     subplot(2,2,2);
%     imagesc(Projection);title('Pool with New Surface');
%     subplot(4,2,5);
%     plot(Projection(PDEPTH,:));title('New Intensity');
%     subplot(4,2,6);
%     imagesc(Projection(PDEPTH,:));
%     subplot(4,2,7);
%     plot(intensity);title('Original Intensity');
%     subplot(4,2,8);
%     imagesc(intensity);
%     figure(gcf);
subplot(6,2,2);
plot(-sSurface,'Color',[0 0 0]);ylabel('Z (cm)','Fontsize', 12);
subplot(6,2,[4 6 8 10]);
imagesc(Projection,[0 SUPERMAX]);figure(gcf);title('');ylabel('Z (cm)','Fontsize', 12);
subplot(6,2,12);
bar(Projection(PDEPTH,:),1,'FaceColor',[0.502 0.502 0.502]);ylabel('Ray Count','Fontsize', 12); xlabel('X (cm)','Fontsize', 12);xlim([1 ESIZE]);
bestSurface=sSurface; %best of all
% disp(countt1);
% disp(countt2);