%calculating fitness
fitness1=0;
SCNWIDTH=5;
fail=0;
maxswap=1;
for i=1:ESIZE-1
    if(indxr(i)<1 || indxr(i)>ESIZE )
        if(i<ESIZE/2)
            indxr(i)=0;
        else
         indxr(i)=ESIZE+1;
        end
    end
   fitness1=fitness1+10*abs(i-indxr(i));
   LL=int32(max(i-SCNWIDTH,1));
   UL=int32(min(i+SCNWIDTH,ESIZE-1));
   divr=abs(abs(indxr(i))-abs((sum(indxr(LL:UL))/(UL-LL))));%calculating local divation
   fitness1=fitness1+divr;
end
%end of computing fitness

for t=1:2000;

%swaping
if(fail>4000)
    maxswap=maxswap+1
    fail=0;
end
for i=1:maxswap
    rnd1=min(1+int32(rand*(ESIZE+1)),ESIZE-1);
    rnd2=min(1+int32(rand*(ESIZE+1)),ESIZE-1);
    temp=indxr(rnd1);
    indxr(rnd1)=indxr(rnd2);
    indxr(rnd2)=temp;
end
%end of swaping



%calculating fitness2
fitness2=0;
for i=1:ESIZE-1
    if(indxr(i)<1 || indxr(i)>ESIZE )
        if(i<ESIZE/2)
            indxr(i)=0;
        else
         indxr(i)=ESIZE+1;
        end
    end
    fitness2=fitness2+10*abs(i-indxr(i));
    LL=max(i-SCNWIDTH,1);
    UL=min(i+SCNWIDTH,ESIZE-1);
    divr=abs(abs(indxr(i))-abs((sum(indxr(LL:UL))/(UL-LL))));%calculating local divation
    fitness2=fitness2+divr;
end
%end of computing fitness

if(mod(t,10)==0)
    %reconstructing the surface
    %reconstructing the surface
    rSurface = zeros(ESIZE,1);
    rSurface(1)=0;
    for i=2:ESIZE
        if(indxr(i-1)<1 || indxr(i-1)>ESIZE )
            if(i<ESIZE/2)
                indxr(i-1)=0;
            else
                indxr(i-1)=ESIZE+1;
            end
        end
        SPD=rSurface(i-1)+PDEPTH;
        triangle=sqrt(SPD^2-2*(indxr(i-1)-(i+0.5)));
        rSurface(i)=rSurface(i-1)+(-SPD+triangle);
    end
    %end of surface reconstruction
%     subplot(4,2,3);
%     plot(-rSurface);title(int2str(fitness2));figure(gcf);
end

if(fitness2<fitness1) % minimization problem
   best=indxr; 
   fitness1=fitness2;
   maxswap=1
   fail=0;
   sSurface=rSurface;
%     subplot(4,2,1);
%     plot(-rSurface);title(int2str(fitness1));figure(gcf);
    %find the x-derivative
    else
   indxr=best;
   fail=fail+1;
end
end % end of the loop
sssdrv=zeros(ESIZE-1,1);
    for i=1:ESIZE-1
        sssdrv(i) = (sSurface(i+1)-sSurface(i));
    end


    %start building the projection matrix (the matrix holding the ray paths)
    curS=(1:(ESIZE-1))+0.5; % half way between two vertices.
    xmin=min(sSurface);
    xmax=max(sSurface);
    difference=abs(xmax-xmin);% pad the the variations fo surface functions to the top of the matrix
    diff32=int32(difference);
    Projection=zeros(diff32+PDEPTH,ESIZE); % setup the image space
    for d=1:diff32+PDEPTH % d is depth from maximum of the surface function.
        for v=1:ESIZE-1
            if((d-diff32)>sSurface(v))
                curS(v)=curS(v)-sssdrv(v);
                tmpX=int32(curS(v));
                if( tmpX > 0 && tmpX < ESIZE)
                    Projection(d,tmpX)=Projection(d,tmpX)+1;
                end
            end
        end
    end
for i=1:ESIZE
    tmpX=int32(sSurface(i))+diff32;
    if(tmpX>0)
        Projection(1:tmpX,i)=-10;
        Projection(tmpX,i)=10;
    end
end
    % end of building the projection 
%     subplot(2,2,2);
%     imagesc(Projection);title('Pool with New Surface');
%     subplot(4,2,5);
%     plot(Projection(PDEPTH,:));title('New Intensity');
%     subplot(4,2,6);
%     imagesc(Projection(PDEPTH,:));
%     subplot(4,2,7);
%     plot(intensity);title('Original Intensity');
%     subplot(4,2,8);
%     imagesc(intensity);
%     figure(gcf);
subplot(6,2,2);
plot(-sSurface,'Color',[0 0 0]);ylabel('Y (1unit)','Fontsize', 12);
subplot(6,2,[4 6 8 10]);
imagesc(Projection,[0 SUPERMAX]);figure(gcf);title('');ylabel('Depth (1unit)','Fontsize', 12);%ylim([0 SUPERMAX])
subplot(6,2,12);
bar(Projection(PDEPTH,:),1,'FaceColor',[0.502 0.502 0.502]);ylabel('Ray Count','Fontsize', 12); xlabel('X (1unit)','Fontsize', 12);xlim([1 ESIZE]);
