clear all;
file_name='fig_section2d.H';
D1=load_history(file_name);
fidd1=fopen(D1.in,'r','ieee-be');
arr_size=[D1.n(1),D1.n(2)];
nelem=arr_size(1)*arr_size(2);
f(1:nelem) = fread(fidd1,nelem,'float32');
Svel=reshape(f,[D1.n(1),D1.n(2)]);

z=[0:D1.n(1)-1]*1;
x=[0:100]*3;

figure('visible','off')
imagesc(Svel)
%set(gca,'YTick',[0:100:600],'YTickLabels',[-0:-100:-600])
colormap('gray')
%caxis([-.05 .09])
xlab=xlabel('x (cm)');
ylab=ylabel('z (cm)');
%tit=title('Synthetic Structural Model');
set(gca,'FontName','Helvetica','FontSize',16,'Clipping','off');
set(xlab,'FontName','Helvetica','FontSize',16);
set(ylab,'FontName','Helvetica','FontSize',16);
%set(tit,'FontName','Helvetica','FontSize',18);
axis image
print -deps2 fig_section2d.ps
exit;
